<?php

namespace Sendeasy;

// Exit if accessed directly
if (!defined('ABSPATH')) {
    exit();
}

/**
 * SE_Formatter class.
 */
class SE_Formatter
{
    /**
     * Formats a phone number.
     *
     * @param string $phone_number
     * @return string
     */
    public static function se_format_phone_number(string $phone_number): string
    {
        // Remove any leading "+" sign.
        $phone_number = preg_replace('/^\+/', '', $phone_number);

        // If the phone number starts with "0", then prepend "27".
        if (substr($phone_number, 0, 1) == '0') {
            $phone_number = '27' . substr($phone_number, 1);
        }

        // Return the formatted phone number.
        return $phone_number;
    }

    /**
     * Formats a number to two decimal places.
     *
     * @param string $number
     * @return string
     */
    public static function se_format_decimal_number_string(string $number): string
    {
        return sprintf('%.2f', floatval($number));
    }
}
