<?php

namespace Sendeasy;

use \Exception;

// Exit if accessed directly.
if (!defined('ABSPATH')) {
    exit();
}

/**
 * SE_XML_Handler class.
 */
class SE_XML_Handler
{
    /**
     * Converts an array with data into an XML string.
     *
     * @param array $data
     * @return string
     */
    public static function se_write_xml(array $data): string
    {
        $xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n
                <soap12:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap12=\"http://www.w3.org/2003/05/soap-envelope\">\n
                <soap12:Body>\n";

        $xml .= "<{$data['soap_action']} xmlns=\"{$data['xmlns']}\">\n";

        foreach ($data['fields'] as $xml_element => $content) {
            $xml .= "<{$xml_element}>{$content}</{$xml_element}>\n";
        }

        $xml .= "</{$data['soap_action']}>\n";

        $xml .= "</soap12:Body>\n
                </soap12:Envelope>";

        return $xml;
    }

    /**
     * Extracts the data from an XML string.
     *
     * @param string $xml
     * @return string
     */
    public static function se_read_xml(string $xml): string
    {
        $content = '';

        try {
            $xml_object = simplexml_load_string($xml);

            $content = (string) $xml_object->children('soap', true)->Body->children()[0]->children()[0];
        } catch (Exception $e) {
            throw $e;
        }

        return $content;
    }
}
